// Button variants
//
// Easily pump out default styles, as well as :hover, :focus, :active,
// and disabled options for all buttons

// scss-lint:disable ColorVariable QualifyingElement

@mixin button-variant($color, $background, $border) {
  color: $color;
  background-color: $background;
  border-color: $border;
  text-decoration: none;
  outline: none;

  &:hover,
  &:focus,
  &.focus,
  &:active,
  &.active {
    background-color: darken($background, 10%);
    border-color: darken($border, 12%);
    color: $color;
  }

  &:active,
  &.active {
    background-image: none;
    box-shadow: inset 0 rem(3) rem(5) rgba(0, 0, 0, .125);
  }

  &.disabled,
  &[disabled],
  fieldset[disabled] & {
    &,
    &:hover,
    &:focus,
    &.focus,
    &:active,
    &.active {
      background-color: $background;
      border-color: $border;
    }
  }
}

@mixin button-ghost($color, $hover) {
  display: inline-block;
  outline: none;
  color: $color;
  background-color: transparent;
  border: rem(2) solid $color;
  text-decoration: none;

  &:hover,
  &:focus,
  &.focus,
  &:active,
  &.active {
    background-color: $color;
    color: $hover;
  }

  &:active,
  &.active {
    background-image: none;
  }

  &.disabled,
  &[disabled],
  fieldset[disabled] & {
    &,
    &:hover,
    &:focus,
    &.focus,
    &:active,
    &.active {
      background-color: $color;
      border-color: $color;
    }
  }
}

// Button sizes
@mixin button-size($padding-vertical, $padding-horizontal, $font-size, $line-height, $border-radius) {
  padding: $padding-vertical $padding-horizontal;
  font-size: $font-size;
  line-height: $line-height;
  border-radius: $border-radius;
}

// scss-lint:enable ColorVariable QualifyingElement
